public with sharing class TestOptoutAndDeclinedMessages {
	public String createPackage() {
        //Create esl client
        ESignLiveSDK sdk = new ESignLiveSDK();
         
        //Create package
        ESignLiveAPIObjects.Package_x pkg = new ESignLiveAPIObjects.Package_x();
        pkg.name = 'Test Optout And Declined Messages - ' + Datetime.now().format();
         
        String packageId = sdk.createPackage(pkg);
        System.debug('PackageId: ' + packageId);
        
        //Add Signer
        String roleResponse = sdk.addRole('John', 'Smith', 'signer1@mailinator.com', packageId);
         
        //Add Document
        StaticResource sr = [SELECT Id, Body FROM StaticResource WHERE Name = 'testdoc1' LIMIT 1];
        Map<String,Blob> doc = new Map<String,Blob>();
        doc.put('Sample Document', sr.Body);
         
        ESignLiveAPIObjects.Document document = new ESignLiveAPIObjects.Document();
        document.name = 'Sample Contract';
        document.id = 'document1';
         
        sdk.createDocuments(packageId, document, doc);
        

        //Add Signature
        Map<String,Object> role = (Map<String,Object>)JSON.deserializeUntyped(roleResponse);
        String roleId = (String)(role.get('id'));
         
        ESignLiveAPIObjects.Field field = new ESignLiveAPIObjects.Field();
        field.left = 208;
        field.width = 200;
        field.height = 50;
        field.top = 518;
        field.page = 0;
        field.subtype = 'FULLNAME';
        field.type = 'SIGNATURE';
         
        List<ESignLiveAPIObjects.Field> fields = new List<ESignLiveAPIObjects.Field>();
        fields.add(field);
         
        ESignLiveAPIObjects.Approval approval = new ESignLiveAPIObjects.Approval();
        approval.fields = fields;
        approval.role = roleId;
         
        String signatureResponse = sdk.addSignature(packageId, 'document1', approval);
         
        //Send package
        pkg.status = ESignLiveAPIObjects.PackageStatus.SENT;
         
        sdk.updatePackage(pkg, packageId);  
        
        return packageId;   
    }
	
    public void retrieveOptoutAndDeclinedMessages(String packageId){
    	ESignLiveSDK sdk = new ESignLiveSDK();
        ESignLiveAPIObjects.Package_x pkg = sdk.getPackage(packageId);
        if(pkg.messages == null || pkg.messages.size() == 0){
        	throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error retrieve Optout And Declined Messages');
        }
        ESignLiveAPIObjects.Message message = pkg.messages.get(0);
        System.Debug(pkg.status.name() + ' reason: ' + message.content);
    }
}